package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 30/12/2018.
 */
public class Employee  implements Transactable ,Worker {

    BankAccount bankAccount ;

    Double expectedHourlyWage ;
    Double expectedHoursWorked ;
    Double expectedBalance ;
    Double expectedBankAccountBalance;

    public Employee() {
    }

    public Employee(BankAccount bankAccount) {

        this.bankAccount =bankAccount ;
        this.expectedHourlyWage =getHourlyWage() ;
        this.expectedHoursWorked =getHoursWorked() ;
        this.expectedBalance=getBalance() ;
        this.expectedBankAccountBalance =getBalance();

    }

    public BankAccount getBankAccount() {

        return bankAccount ;
    }

    public void setBankAccount(BankAccount bankAccount) {
       this.bankAccount =bankAccount ;

    }

//    public void setExpectedHoursWorked(Double expectedHoursWorked ){
//        this.expectedHoursWorked =expectedHoursWorked ;
//    }
//     public void setExpectedHourlyWage (Double expectedHourlyWage ){
//        this.expectedHourlyWage =expectedHourlyWage;
//     }
//
//     public void setExpectedBankAccountBalance (Double  expectedBankAccountBalance ){
//        this.expectedBankAccountBalance=expectedBankAccountBalance ;
//     }
//     public void setExpectedBalance (Double expectedBalance ){
//        this.expectedBalance =expectedBalance ;
//     }
    @Override
    public void increaseHoursWorked(Double numberOfHours) {
        expectedHoursWorked +=numberOfHours ;

    }

    @Override
    public Double getHoursWorked() {

        return expectedHoursWorked;
    }

    @Override
    public Double getHourlyWage() {

        return expectedHourlyWage ;
    }

    @Override
    public Double getMoneyEarned() {

        return expectedBalance;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        expectedBalance +=amountToIncreaseBy;

    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {

        expectedBalance-=amountToDecreaseBy;
    }

    @Override
    public Double getBalance() {
        return expectedBalance;
    }
}
